/* -*- c-basic-offset: 4 indent-tabs-mode: nil -*-  vi:set ts=8 sts=4 sw=4: */

#ifndef _FD_WRITE_ACTION_H_
#define _FD_WRITE_ACTION_H_

#include "Action.h"

#include <map>

#include <QMutex>

class FDWriteAction : public Action    
{
    Q_OBJECT

public:
    FDWriteAction(QString file, QString data, bool togglePrevious);
    virtual ~FDWriteAction();

    virtual QString getName() const;
    virtual void fire();

protected:
    int m_fd;
    QString m_data;
    bool m_togglePrevious;
    QMutex m_mutex;
    static std::map<QString, int> m_fdMap;
    static QString m_previousData;
};

#endif
