/* -*- c-basic-offset: 4 indent-tabs-mode: nil -*-  vi:set ts=8 sts=4 sw=4: */

#include "ImageAction.h"
#include "ImageWindow.h"

#include <iostream>

QString
ImageAction::m_currentImage;

ImageAction::ImageAction(QString imageName) :
    m_imageName(imageName)
{
    connect(this, SIGNAL(showImage(QString)),
            ImageWindow::getInstance(), SLOT(showImage(QString)));
}

ImageAction::~ImageAction()
{
}

QString
ImageAction::getName() const
{
    return QString("image: %1").arg(m_imageName);
}

void
ImageAction::fire()
{
    if (m_currentImage == m_imageName) return;
    std::cerr << "ImageAction(\"" << getName().toStdString() << "\")::fire"
              << std::endl;
    m_currentImage = m_imageName;
    emit showImage(m_imageName);
}

